%global dlrn 1
%define upstream_version 11.0.0
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global drv_vendor VMware
%global srcname vmware-nsx
%global docpath doc/build/html
%global service neutron
%global pyname vmware_nsx

%global with_doc 0

Name:           python-networking-%{srcname}
Version: 	11.0.0
Release: 	2%{?dist}
Provides: 	python2-networking-vmware-nsx = %{version}-%{release}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
# TODO: really, there are no packages on PyPI or anywhere else
URL:            https://pypi.python.org/pypi/%{srcname}
Source0: 	http://tarballs.openstack.org/%{srcname}/%{srcname}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=11.0.0
Patch0001: 0001-NSX-V-complete-init-of-fwaas-core-plugin.patch
Patch0002: 0002-Add-NSXv3-LBaaS-driver-config-for-devstack.patch
Patch0003: 0003-NSXv3-Fix-L7-rule-create-delete-base-on-latest-API.patch
Patch0004: 0004-NSXv3-Fix-a-typo-in-LBaaS-member_mgr.patch
Patch0005: 0005-Updated-from-global-requirements.patch
Patch0006: 0006-NSX-V-add-exception-log-if-router-create-fails.patch
Patch0007: 0007-NSX-V-check-md-proxy-handler-exists-before-usage.patch
Patch0008: 0008-NSXv3-Handle-floating-ip-for-loadbalancer-VIP.patch
Patch0009: 0009-NSXv3-Fix-loadbalancer-stats-exception.patch
Patch0010: 0010-NSXv3-Change-LB-rule-match-type-to-REGEX.patch
Patch0011: 0011-NSXv3-Change-reponse-code-for-L7-redirect-and-reject.patch
Patch0012: 0012-NSXv3-Fix-LB-pool-algorithm.patch
Patch0013: 0013-zuul-v3-gate-changes.patch
Patch0014: 0014-NSXv3-Update-router-advertise_lb_vip.patch
Patch0015: 0015-NSX-V-fix-exclude-list-counting.patch
Patch0016: 0016-NSXv-Recover-from-LBaaSv2-HM-inconsistency.patch
Patch0017: 0017-NSX-V-add-shared-router-logs.patch
Patch0018: 0018-Fix-shared-routers-locks.patch
Patch0019: 0019-NSX-V-Fix-get_dhcp_binding-output-parsing.patch
Patch0020: 0020-NSXv3-Fix-load-balancer-delete-issue.patch
Patch0021: 0021-NSXv3-Limit-tag-value-to-maximum-40.patch
Patch0022: 0022-NSX-V3-Do-not-allow-adding-QoS-to-dhcp-ports.patch
Patch0023: 0023-NSX-V3-use-contexts-user_identity-for-the-X-NSX-EUSE.patch
Patch0024: 0024-NSX-V3-fix-lbaas-get-plugin-code.patch
Patch0025: 0025-NSXv3-Fix-TERMINATED_HTTPS-listener.patch
Patch0026: 0026-NSXv3-Update-tag-if-lb-name-is-updated.patch
Patch0027: 0027-NSX-V3-allow-updating-a-floatingip-without-changing-.patch
Patch0028: 0028-NSX-v-Fix-provider-network-creation.patch
Patch0029: 0029-NSX-Migration-of-default-security-groups.patch
Patch0030: 0030-NSX-v-validate-PG-provider-networks.patch
Patch0031: 0031-NSXv3-Add-validation-when-attaching-lbs-to-router.patch
Patch0032: 0032-NSXv3-Enforce-only-one-l7rule-per-l7policy.patch
Patch0033: 0033-NSX-V3-ensure-that-a-readable-name-is-set-for-LB-res.patch
Patch0034: 0034-NSXv3-Check-cert-existance-before-creation.patch
Patch0035: 0035-NSX-V3-address-edge-case-of-subnet-deletion-when-att.patch
Patch0036: 0036-NSX-V3-enforce-provider-rules-not-being-set-when-not.patch
Patch0037: 0037-NSX-V3-fix-create-port-with-provider-security-group.patch
Patch0038: 0038-NSX-V3-Do-not-enable-port-security-on-router-interfa.patch
Patch0039: 0039-NSXv3-Fix-listener-pool-update.patch
Patch0040: 0040-NSXv3-Fix-pool-member-update.patch
Patch0041: 0041-NSXv3-Update-VIP-on-multiple-listeners.patch
Patch0042: 0042-NSXv3-Update-FIP-on-VIP-gracefully.patch
Patch0043: 0043-NSX-v-Add-qos-policy-id-to-port.patch
Patch0044: 0044-NSXv3-Validate-LB-router-gateway.patch
Patch0045: 0045-NSXv3-Fix-a-typo-to-return-router_id.patch
Patch0046: 0046-NSXv3-Handle-association-fip-to-vip-in-different-cas.patch
Patch0047: 0047-Add-metadata-setting-for-new-created-dhcp-edge.patch
Patch0048: 0048-NSX-V3-ensure-that-metadata-works-with-windows-insta.patch
Patch0049: 0049-NSX-V-prevent-deleting-md-proxy-neutron-objects.patch
Patch0050: 0050-NSX-V3-ensure-provider-securiry-updates-are-done.patch
Patch0051: 0051-NSX-V-Fix-Fwaas-for-distributed-router.patch
Patch0052: 0052-NSXv3-Continue-HM-delete-in-case-of-inconsistence.patch
Patch0053: 0053-NSX-v-v3-Prevent-adding-default-route-to-router.patch
Patch0054: 0054-NSX-v-Fix-VPNaaS-driver.patch
Patch0055: 0055-NSX-v-v3-Prevent-adding-0.0.0.0-route-to-router.patch
Patch0056: 0056-NSX_V3-make-sure-that-member-creation-is-serialized.patch
Patch0057: 0057-NSX_V3-enable-non-native-DHCP-to-work-with-AZ-suppor.patch
Patch0058: 0058-AdminUtils-NSX-V3-Show-and-update-the-NSX-rate-limit.patch
Patch0059: 0059-Retry-with-stale-DB-values.patch
Patch0060: 0060-NSX-V-ensure-that-only-LAG-is-configured-and-not-sta.patch
Patch0061: 0061-Use-the-new-PTI-for-document-build.patch
Patch0062: 0062-NSX-V-make-sure-error-fw-can-be-deleted.patch

BuildArch:      noarch
BuildRequires:  openstack-macros
BuildRequires:  python2-devel
BuildRequires:  python-mock
BuildRequires:  python-oslo-sphinx
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  python-tenacity
BuildRequires:  python-vmware-nsxlib
# Required for config file generation
BuildRequires:  python-debtcollector
BuildRequires:  python-oslo-config >= 2:4.0.0
BuildRequires:  python-oslo-i18n >= 2.1.0
BuildRequires:  python-oslo-vmware >= 2.17.0
BuildRequires:  python-neutron

Requires:       python-decorator
Requires:       python-enum34
Requires:       python-eventlet
Requires:       python-httplib2 >= 0.7.5
Requires:       python-netaddr >= 0.7.13
Requires:       python-neutron
Requires:       python-neutron-lib >= 1.9.0
Requires:       python-openstackclient >= 3.3.0
Requires:       python-osc-lib >= 1.7.0
Requires:       python-oslo-concurrency >= 3.8.0
Requires:       python-oslo-config >= 2:4.0.0
Requires:       python-oslo-db >= 4.24.0
Requires:       python-oslo-i18n >= 2.1.0
Requires:       python-oslo-log >= 3.22.0
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-service >= 1.10.0
Requires:       python-oslo-utils >= 3.20.0
Requires:       python-oslo-vmware >= 2.17.0
Requires:       python-pbr >= 2.0.0
Requires:       python-prettytable
Requires:       python-six >= 1.9.0
Requires:       python-sqlalchemy >= 1.0.10
Requires:       python-stevedore >= 1.20.0
Requires:       python-tenacity >= 3.2.1
Requires:       python-tooz >= 1.47.0
Requires:       python-vmware-nsxlib

%description
This package contains %{drv_vendor} networking driver for OpenStack Neutron.


%if 0%{?with_doc}
%package doc
Summary:        %{summary} documentation
Requires:       %{name} = %{version}-%{release}


%description doc
This package contains documentation for %{drv_vendor} networking driver for
OpenStack Neutron.
%endif

%prep
%setup -q -n %{srcname}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1

rm requirements.txt test-requirements.txt


%build
%{__python2} setup.py build

%if 0%{?with_doc}
%{__python2} setup.py build_sphinx
rm %{docpath}/.buildinfo
%endif


%install
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py install --skip-build --root %{buildroot}

# Build config file
PYTHONPATH=. tools/generate_config_file_samples.sh

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware
mv etc/nsx.ini.sample %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware/nsx.ini

%files
%license LICENSE
%{_bindir}/nsx-migration
%{_bindir}/neutron-check-nsx-config
%{_bindir}/nsxadmin
%{python2_sitelib}/%{pyname}
%{python2_sitelib}/%{pyname}-%{version}-py%{python2_version}.egg-info
%dir %{_sysconfdir}/%{service}/plugins/vmware
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/vmware/*.ini


%if 0%{?with_doc}
%files doc
%license LICENSE
%doc %{docpath}
%endif

%changelog
* Thu Feb 15 2018 Thierry Vignaud <tvignaud@redhat.com> 11.0.0-2
- NSX-V: make sure error fw can be deleted
- Use the new PTI for document build
- NSX|V: ensure that only LAG is configured and not standby
- Retry with stale DB values
- AdminUtils: NSX-V3: Show and update the NSX rate limit
- NSX_V3: enable non native DHCP to work with AZ support
- NSX_V3: make sure that member creation is serialized
- NSX|v+v3: Prevent adding 0.0.0.0 route to router
- NSX-v: Fix VPNaaS driver
- NSX|v+v3: Prevent adding default route to router
- NSXv3: Continue HM delete in case of inconsistence
- NSX|V: Fix Fwaas for distributed router
- NSX|V3: ensure provider securiry updates are done
- NSX|V prevent deleting md proxy neutron objects
- NSX|V3: ensure that metadata works with windows instances
- Add metadata setting for new created dhcp edge.
- NSXv3: Handle association fip to vip in different cases
- NSXv3: Fix a typo to return router_id
- NSXv3: Validate LB router gateway
- NSX|v: Add qos policy id to port
- NSXv3: Update FIP on VIP gracefully
- NSXv3: Update VIP on multiple listeners
- NSXv3: Fix pool member update
- NSXv3: Fix listener/pool update
- NSX|V3: Do not enable port security on router interface
- NSX|V3: fix create port with provider security group
- NSX|V3: enforce provider rules not being set when not port sec
- NSX|V3: address edge case of subnet deletion when attached to router
- NSXv3: Check cert existance before creation
- NSX|V3: ensure that a readable name is set for LB resources on NSX
- NSXv3: Enforce only one l7rule per l7policy
- NSXv3: Add validation when attaching lbs to router
- NSX|v validate PG provider networks
- NSX-Migration of default security groups
- NSX|v: Fix provider network creation
- NSX|V3: allow updating a floatingip without changing the port
- NSXv3: Update tag if lb name is updated
- NSXv3: Fix TERMINATED_HTTPS listener
- NSX|V3 fix lbaas get plugin code
- NSX|V3: use contexts 'user_identity' for the 'X-NSX-EUSER' header
- NSX-V3| Do not allow adding QoS to dhcp ports
- NSXv3: Limit tag value to maximum 40
- NSXv3: Fix load balancer delete issue
- NSX|V Fix get_dhcp_binding output parsing
- Fix shared routers locks

* Mon Nov 20 2017 Jason Joyce <jjoyce@redhat.com> 11.0.0-1
- NSX|V add shared router logs
- NSXv: Recover from LBaaSv2 HM inconsistency
- NSX|V fix exclude list counting
- NSXv3: Update router advertise_lb_vip
- zuul v3 gate changes
- NSXv3: Fix LB pool algorithm
- NSXv3: Change reponse code for L7 redirect and reject
- NSXv3: Change LB rule match type to REGEX
- NSXv3: Fix loadbalancer stats exception
- NSXv3: Handle floating ip for loadbalancer VIP
- NSX|V: check md proxy handler exists before usage
- NSX|V: add exception log if router create fails
- Updated from global requirements
- NSXv3: Fix a typo in LBaaS member_mgr
- NSXv3: Fix L7 rule create/delete base on latest API
- Add NSXv3 LBaaS driver config for devstack
- NSX|V complete init of fwaas core plugin
- Update to 11.0.0

